﻿using System.Collections.Generic;
using Mono.Cecil;
using Mono.Cecil.Cil;
// Решил всё оформить как наст деобфускатор для обфускатора 9rays
// Выложу в паблик, дабы не гребли мешками с людей денег ребята из 9rays
// Спс zeppe1in)
// Для полного капитулирования NineRays, надо:
// Resources Decrypter
// Strings Decrypter
// И всё.
// Я думаю, что .NET Reactor со CliSecure крякнули, Spices .NET тоже получится
// Я тут переделал чуточку ринэймер (можно настроить под себя)
// Только проблема с Control-Flow деобфускацией. Вылетает InvalidOperationException - операция невозможна из-за текущего состояния объекта
// Пока работает не оч прям хорошо, ну чтоЖ))
namespace NineRays.Deobfuscator
{
    // Главный класс
    public class Deobfuscator
    {
        // Привычный ринэймер, думаю есть в любом уважающем себя деобфускаторе
        public sealed class Renamer
        {
            static string defaultPrefixForType = "t";
            static bool firstPrefixForType = true;
            static string currentPrefixForType = defaultPrefixForType;
            public static string PrefixForType
            {
                get
                {
                    if (firstPrefixForType)
                    {
                        firstPrefixForType = false;
                        return defaultPrefixForType;
                    }
                    return currentPrefixForType;
                }
                set
                {
                    currentPrefixForType = value;
                }
            }
            static string defaultPrefixForField = "f";
            static bool firstPrefixForField = true;
            static string currentPrefixForField = defaultPrefixForField;
            public static string PrefixForField
            {
                get
                {
                    if (firstPrefixForField)
                    {
                        firstPrefixForField = false;
                        return defaultPrefixForField;
                    }
                    return currentPrefixForField;
                }
                set
                {
                    currentPrefixForField = value;
                }
            }
            static string defaultPrefixForProperty = "p";
            static bool firstPrefixForProperty = true;
            static string currentPrefixForProperty = defaultPrefixForProperty;
            public static string PrefixForProperty
            {
                get
                {
                    if (firstPrefixForProperty)
                    {
                        firstPrefixForProperty = false;
                        return defaultPrefixForProperty;
                    }
                    return currentPrefixForProperty;
                }
                set
                {
                    currentPrefixForProperty = value;
                }
            }
            static string defaultPrefixForEvent = "e";
            static bool firstPrefixForEvent = true;
            static string currentPrefixForEvent = defaultPrefixForEvent;
            public static string PrefixForEvent
            {
                get
                {
                    if (firstPrefixForEvent)
                    {
                        firstPrefixForEvent = false;
                        return defaultPrefixForEvent;
                    }
                    return currentPrefixForEvent;
                }
                set
                {
                    currentPrefixForEvent = value;
                }
            }
            static string defaultPrefixForMethod = "m";
            static bool firstPrefixForMethod = true;
            static string currentPrefixForMethod = defaultPrefixForMethod;
            public static string PrefixForMethod
            {
                get
                {
                    if (firstPrefixForMethod)
                    {
                        firstPrefixForMethod = false;
                        return defaultPrefixForMethod;
                    }
                    return currentPrefixForMethod;
                }
                set
                {
                    currentPrefixForMethod = value;
                }
            }
            static string defaultPrefixForParam = "pm";
            static bool firstPrefixForParam = true;
            static string currentPrefixForParam = defaultPrefixForParam;
            public static string PrefixForParam
            {
                get
                {
                    if (firstPrefixForParam)
                    {
                        firstPrefixForParam = false;
                        return defaultPrefixForParam;
                    }
                    return currentPrefixForParam;
                }
                set
                {
                    currentPrefixForParam = value;
                }
            }
            static bool _typeDetection = false;
            public static bool TypeDetection
            {
                get { return _typeDetection; }
                set { _typeDetection = value; }
            }
            static int _typeCurrentNumber = 0;
            public static void RenameAllMembersInType(TypeDefinition type)
            {
                int _eventCurrentNumber = 0;
                int _fieldCurrentNumber = 0;
                int _methodCurrentNumber = 0;
                int _propertyCurrentNumber = 0;
                int _paramCurrentNumber = 0;
                if (type.HasNestedTypes)
                {
                    foreach (var nestedType in type.NestedTypes)
                    {
                        RenameAllMembersInType(nestedType);
                    }
                }
                _typeCurrentNumber++;
                string StartingName = PrefixForType;
                string Number = _typeCurrentNumber.ToString();
                string typeBaseTypeName = "None";
                if (_typeDetection)
                    typeBaseTypeName = type.BaseType.Name;
                string Name = string.Concat(new string[] {
                StartingName,
                "_",
                Number,
                "_", 
                typeBaseTypeName });
                type.Name = Name;
                foreach (var property in type.Properties)
                {
                    string StartingNameP = PrefixForProperty;
                    string NumberP = _propertyCurrentNumber.ToString();
                    string propertyType = "None";
                    if (_typeDetection)
                        propertyType = property.DeclaringType.Name;
                    string NameP = string.Concat(new string[] 
               {
               StartingNameP,
               "_",
               NumberP,
               "_",
               propertyType
               });
                    property.Name = Name;
                    _propertyCurrentNumber++;
                }
                _propertyCurrentNumber = 0;
                foreach (var evenT in type.Events)
                {
                    string StartingNameE = PrefixForEvent;
                    string NumberE = _eventCurrentNumber.ToString();
                    string EventType = "None";
                    if (_typeDetection)
                        EventType = evenT.EventType.Name;
                    string NameE = string.Concat(new string[] {
                    StartingNameE,
                    "_",
                    NumberE,
                    "_",
                    EventType
                });
                    evenT.Name = NameE;
                    _eventCurrentNumber++;
                }
                _eventCurrentNumber = 0;
                foreach (var field in type.Fields)
                {
                    string StartingNameF = PrefixForField;
                    string NumberF = _fieldCurrentNumber.ToString();
                    string fieldType = "None";
                    if (_typeDetection)
                        fieldType = field.FieldType.Name;
                    string NameF = string.Concat(new string[] 
            {
               StartingNameF,
               "_",
               NumberF,
               "_",
               fieldType
            });
                    field.Name = NameF;
                    _fieldCurrentNumber++;
                }
                _fieldCurrentNumber = 0;
                foreach (var method in type.Methods)
                {
                    string StartingNameM = PrefixForMethod;
                    string NumberM = _methodCurrentNumber.ToString();
                    string methodType = "None";
                    if (_typeDetection)
                        methodType = method.ReturnType.Name;
                    string NameM = string.Concat(new string[] 
            {
               StartingNameM,
               "_",
               NumberM,
               "_",
               methodType
            });
                    method.Name = NameM;
                    _methodCurrentNumber++;
                    if (method.HasParameters)
                    {
                        foreach (var param in method.Parameters)
                        {
                            string StartingNameMPar = PrefixForMethod;
                            string NumberPar = _paramCurrentNumber.ToString();
                            string paramType = "None";
                            if (_typeDetection)
                                paramType = param.ParameterType.Name;
                            string NameParam = string.Concat(new string[] 
            {
               StartingNameMPar,
               "_",
               NumberPar,
               "_",
               paramType
            });
                            param.Name = NameParam;
                            _paramCurrentNumber++;
                        }
                    }
                }
                _methodCurrentNumber = 0;
            }
        }
        public sealed class ControlFlowRemover
        {
            public void RemoveFakeMethodsIntoReal(TypeDefinition type)
            {
                List<TypeDefinition> UsedNestedTypes = new List<TypeDefinition>();
                TypeDefinition[] NestedTypes = type.NestedTypes.ToArray();
                List<MethodDefinition> FakeMethods = new List<MethodDefinition>();
                List<MethodDefinition> RealMethods = new List<MethodDefinition>();
                foreach (var nestType in NestedTypes)
                    foreach (var method in nestType.Methods)
                        FakeMethods.Add(method);
                foreach (var meth in type.Methods)
                    RealMethods.Add(meth);
                foreach (var realMeth in RealMethods)
                {
                    foreach (var fakeMethod in FakeMethods)
                    {
                        foreach (var ins in realMeth.Body.Instructions)
                        {
                            if (ins.OpCode == OpCodes.Call || ins.OpCode == OpCodes.Callvirt)
                            {
                                if (ins.Operand is MethodReference)
                                {
                                    MethodReference refer = (MethodReference)ins.Operand;
                                    if (refer.MetadataToken == fakeMethod.MetadataToken)//проверять по токену а не имени
                                    {
                                        try
                                        {
                                            Instruction[] FakeInstructions = fakeMethod.Body.Instructions.ToArray();

                                            int p = fakeMethod.Parameters.Count;
                                            //проверяем подходит ли для деобфускации
                                            ILProcessor replacer = realMeth.Body.GetILProcessor();
                                            if (FakeInstructions[p].OpCode == OpCodes.Callvirt ||
                                                FakeInstructions[p].OpCode == OpCodes.Call ||
                                                FakeInstructions[p].OpCode == OpCodes.Ldfld &&
                                                FakeInstructions[p + 1].OpCode == OpCodes.Ret)
                                            {
                                                replacer.Replace(ins, FakeInstructions[p]);
                                            }
                                        }
                                        catch { continue; }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}
